/* pthread_attributes */

#include "pthread.h"
#include "pthread_private.h"

int pthread_attr_init (pthread_attr_t * attr) {
	pthread_attr_t pattr;
	
	if ((pattr = (pthread_attr_t)malloc(sizeof(pthread_attr_t))) == NULL)
		return ENOMEM;
	memcpy(pattr, &pthread_attr_default, sizeof(pattr));
	*attr = pattr;
	return 0;
}

int	pthread_attr_destroy (pthread_attr_t *attr) {

	if (attr == NULL || *attr == NULL)
		return EINVAL;
	
	free((*attr));
	*attr = NULL;
	return 0;
}

