/* private routines for pthreads *
 *
 * only functions that go in here are ones that are unqiue to BeOS and are
 * are private within the library...
 *
 * all pthread code should be in seperate files.
 *
 */
 
#include "pthread.h"
#include "pthread_private.h"
#include <malloc.h>

static _pthread_benaphore * _thread_list_lock = NULL;

const inline void _pthread_benaphore_init(_pthread_benaphore * bb) {
    bb->sem = create_sem(0,"pthread_benaphore");
    bb->ben = 0;
}

const inline void _pthread_benaphore_lock(_pthread_benaphore * bb) {
    if (atomic_add(&bb->ben,1)>0)
        if (acquire_sem(bb->sem) != B_NO_ERROR)
            atomic_add(&bb->ben,-1);
}

const inline void _pthread_benaphore_unlock(_pthread_benaphore * bb) {
    if (atomic_add(&bb->ben,-1)>1)
        release_sem(bb->sem);
}

const inline void _pthread_benaphore_destroy(_pthread_benaphore * bb) {
    delete_sem(bb->sem);
}

void _lock_thread_list() {
	if (_thread_list_lock == NULL) {
		_thread_list_lock = malloc(sizeof(_pthread_benaphore));
		_pthread_benaphore_init(_thread_list_lock);
	}
	_pthread_benaphore_lock(_thread_list_lock);
}

void _unlock_thread_list() {
	_pthread_benaphore_unlock(_thread_list_lock);
}

