/* the queue functions for thread_queue's */
#include "pthread.h"
#include "pthread_private.h"

void _thread_queue_init(struct pthread_queue * q) {
    q->q_next = NULL;
    q->q_last = NULL;
    q->q_data = NULL;
    return;
}

void _thread_queue_enq(struct pthread_queue *q, struct pthread * thread) {
    if (q->q_last) {
        q->q_last->qnxt = thread;
    } else {
        q->q_next = thread;
    }
    q->q_last = thread;
    thread->queue = q;
    thread->qnxt = NULL;
    return;
}

struct pthread * _thread_queue_deq(struct pthread_queue *q) {
    struct pthread *thread = NULL;
    
    if (q->q_next) {
        thread = q->q_next;
        if (! (q->q_next = q->q_next->qnxt)) {
            q->q_last = NULL;
        }
        thread->queue = NULL;
        thread->qnxt = NULL;
    }
    return (thread);
}

struct pthread * _thread_queue_get(struct pthread_queue * q) {
    return (q->q_next);
}

int _thread_queue_remove(struct pthread_queue *q, struct pthread *thread) {
    struct pthread **curr = &(q->q_next);
    struct pthread *prev = NULL;
    int rv = -1;
    
    while (*curr) {
        if (*curr == thread) {
            if ((*curr)->qnxt) {
                *curr = (*curr)->qnxt;
            } else {
                q->q_last = prev;
                *curr = NULL;
            }
	        rv = 0;
    	    break;
    	}
    	prev = *curr;
    	curr = &((*curr)->qnxt);
    }
    thread->queue = NULL;
    thread->qnxt = NULL;
    return (rv);
}
