#include "pthread.h"
#include <unistd.h>
#include <stdio.h>


int32 thread_func1(void *data);
int32 thread_func2(void *data);
int32 thread_func3(void *data);
int32 thread_func4(void *data);


pthread_mutex_t thread_lock, cond_lock;
pthread_cond_t cond;
int x = 0;

int32 thread_func1(void *data)
{
    int i;
    struct timespec atime;
    atime.tv_sec = 10;
    atime.tv_usec = 0;
    pthread_cond_timedwait(&cond, &cond_lock, &atime);

    for (i = 0; i < 10000; i++) {
        pthread_mutex_lock(&thread_lock);
        x++;
        pthread_mutex_unlock(&thread_lock);
    }
    return 0;
} 

int32 thread_func2(void *data)
{
    int i;
    pthread_cond_wait(&cond, &cond_lock);

    for (i = 0; i < 10000; i++) {
        pthread_mutex_lock(&thread_lock);
        x++;
        pthread_mutex_unlock(&thread_lock);
    }
    return 0;
} 

int32 thread_func3(void *data)
{
    int i;
    pthread_cond_wait(&cond, &cond_lock);

    for (i = 0; i < 10000; i++) {
        pthread_mutex_lock(&thread_lock);
        x++;
        pthread_mutex_unlock(&thread_lock);
    }
    return 0;
} 

int32 thread_func4(void *data)
{
    int i;
    pthread_cond_wait(&cond, &cond_lock);

    for (i = 0; i < 10000; i++) {
        pthread_mutex_lock(&thread_lock);
        x++;
        pthread_mutex_unlock(&thread_lock);
    }
    return 0;
} 

int main()
{
    pthread_t t1;
    pthread_t t2;
    pthread_t t3;
    pthread_t t4;
    pthread_attr_t ta1;
    pthread_attr_t ta2;
    pthread_attr_t ta3;
    pthread_attr_t ta4;
    pthread_attr_t attr;
    
    int s1;
    int s2;
    int s3;
    int s4;
	int i;
	
    fprintf(stdout, "Initializing the thread attribute....."); 
    if (pthread_attr_init(&attr) != 0) { 
        fprintf(stderr, "Could not create lock\n");
        exit(-1);
    }
    fprintf(stdout, "OK\n");
	
    fprintf(stdout, "Initializing the locks................"); 
    s1 = pthread_mutex_init(&thread_lock, NULL); 
    if (s1 != 0) {
        fprintf(stderr, "Could not create lock\n");
        exit(-1);
    }
    s1 = pthread_mutex_init(&cond_lock, NULL); 
    if (s1 != 0) {
        fprintf(stderr, "Could not create lock\n");
        exit(-1);
    }
    fprintf(stdout, "OK\n");

	fprintf(stdout,"Creating the conditional variable.....");
	s1 = pthread_cond_init(&cond, NULL);
    if (s1 != 0) {
        fprintf(stderr, "Could not create conditional: 0x%x, %s\n",s1,strerror(s1));
        exit(-1);
    }
    fprintf(stdout, "OK\n");
	
    fprintf(stdout, "Starting all the threads.............."); 
    s1 = pthread_create(&t1, &ta1, thread_func1, &attr);
    s2 = pthread_create(&t2, &ta2, thread_func2, &attr);
    s3 = pthread_create(&t3, &ta3, thread_func3, &attr);
    s4 = pthread_create(&t4, &ta4, thread_func4, &attr);
    if (s1 != 0 || s2 != 0 || 
        s3 != 0 || s4 != 0) {
        fprintf(stderr, "Error starting thread\n");
        exit(-1);
    }
    fprintf(stdout, "OK\n");
	
	fprintf (stdout,"Trying to signal conditional..........");
	
	if (pthread_cond_signal(&cond) != 0)
		fprintf (stdout,"failed!\n");
    else
    	fprintf(stdout,"OK\n");

	fprintf (stdout,"Trying to broadcast conditional.......");
	if (pthread_cond_broadcast(&cond) != 0)
		fprintf (stdout,"failed!\n");
   else
    	fprintf(stdout,"OK\n");

    fprintf(stdout, "Waiting for threads to exit...........");
    pthread_join(t1, (void**)s1);
    pthread_join(t2, (void**)s2);
    pthread_join(t3, (void**)s3);
    pthread_join(t4, (void**)s4);
    fprintf (stdout, "OK\n");   

    fprintf(stdout, "Checking if locks worked.............."); 
    if (x != 40000) {
        fprintf(stderr, "The locks didn't work????  %d\n", x);
    }
    else {
        fprintf(stdout, "Everything is working!\n");
    }

	fprintf(stdout,"Destroying pthread variables used.\n");
	pthread_attr_destroy(&attr);
	pthread_mutex_destroy(&cond_lock);
	pthread_mutex_destroy(&thread_lock);
	pthread_cond_destroy(&cond);	
    return 1;
}
